# Generated by Django 4.1.7 on 2023-05-29 11:49

import django.contrib.gis.db.models.functions
import django.contrib.postgres.constraints
import django.contrib.postgres.indexes
import django.db.models.constraints
import django.db.models.deletion
import django.db.models.functions.comparison
from django.conf import settings
from django.contrib.postgres.operations import BtreeGistExtension
from django.db import migrations, models

import arkindex.documents.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("process", "0002_initial"),
        ("documents", "0002_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("images", "0001_initial"),
    ]

    operations = [
        BtreeGistExtension(),
        migrations.AddField(
            model_name="selection",
            name="user",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="selections", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="mlclass",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="ml_classes", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="metadata",
            name="element",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="metadatas", to="documents.element"),
        ),
        migrations.AddField(
            model_name="metadata",
            name="entity",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="metadatas", to="documents.entity"),
        ),
        migrations.AddField(
            model_name="metadata",
            name="worker_run",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name="metadatas", to="process.workerrun"),
        ),
        migrations.AddField(
            model_name="metadata",
            name="worker_version",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="metadatas", to="process.workerversion"),
        ),
        migrations.AddField(
            model_name="entitytype",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="entity_types", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="entityrole",
            name="child_type",
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name="child_role", to="documents.entitytype"),
        ),
        migrations.AddField(
            model_name="entityrole",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="roles", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="entityrole",
            name="parent_type",
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name="parent_role", to="documents.entitytype"),
        ),
        migrations.AddField(
            model_name="entitylink",
            name="child",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="children", to="documents.entity"),
        ),
        migrations.AddField(
            model_name="entitylink",
            name="parent",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="parents", to="documents.entity"),
        ),
        migrations.AddField(
            model_name="entitylink",
            name="role",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="links", to="documents.entityrole"),
        ),
        migrations.AddField(
            model_name="entity",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="entities", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="entity",
            name="moderator",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="entities", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="entity",
            name="type",
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name="entities", to="documents.entitytype"),
        ),
        migrations.AddField(
            model_name="entity",
            name="worker_run",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name="entities", to="process.workerrun"),
        ),
        migrations.AddField(
            model_name="entity",
            name="worker_version",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="entities", to="process.workerversion"),
        ),
        migrations.AddField(
            model_name="elementtype",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="types", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="elementpath",
            name="element",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="paths", to="documents.element"),
        ),
        migrations.AddField(
            model_name="element",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="elements", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="element",
            name="creator",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="elements", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="element",
            name="image",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="elements", to="images.image"),
        ),
        migrations.AddField(
            model_name="element",
            name="type",
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name="elements", to="documents.elementtype"),
        ),
        migrations.AddField(
            model_name="element",
            name="worker_run",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name="elements", to="process.workerrun"),
        ),
        migrations.AddField(
            model_name="element",
            name="worker_version",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="elements", to="process.workerversion"),
        ),
        migrations.AddField(
            model_name="corpusexport",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="exports", to="documents.corpus"),
        ),
        migrations.AddField(
            model_name="corpusexport",
            name="user",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="exports", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="corpus",
            name="top_level_type",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="top_level_corpora", to="documents.elementtype"),
        ),
        migrations.AddField(
            model_name="classification",
            name="element",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="classifications", to="documents.element"),
        ),
        migrations.AddField(
            model_name="classification",
            name="ml_class",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="classifications", to="documents.mlclass"),
        ),
        migrations.AddField(
            model_name="classification",
            name="moderator",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="classifications", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="classification",
            name="worker_run",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name="classifications", to="process.workerrun"),
        ),
        migrations.AddField(
            model_name="classification",
            name="worker_version",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name="classifications", to="process.workerversion"),
        ),
        migrations.AddField(
            model_name="allowedmetadata",
            name="corpus",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name="allowed_metadatas", to="documents.corpus"),
        ),
        migrations.AddConstraint(
            model_name="transcriptionentity",
            constraint=models.CheckConstraint(check=models.Q(("worker_version_id__isnull", False), ("worker_run_id__isnull", True), _connector="OR"), name="transcription_entity_worker_run_requires_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="transcriptionentity",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_version_id__isnull", True)), fields=("transcription", "entity", "offset", "length"), name="transcription_entity_unique_manual"),
        ),
        migrations.AddConstraint(
            model_name="transcriptionentity",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_run_id__isnull", True), ("worker_version_id__isnull", False)), fields=("transcription", "entity", "offset", "length", "worker_version"), name="transcription_entity_unique_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="transcriptionentity",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_run_id__isnull", False)), fields=("transcription", "entity", "offset", "length", "worker_run"), name="transcription_entity_unique_worker_run"),
        ),
        migrations.AddConstraint(
            model_name="transcription",
            constraint=models.CheckConstraint(check=models.Q(("worker_version_id__isnull", False), ("worker_run_id__isnull", True), _connector="OR"), name="transcription_worker_run_requires_worker_version"),
        ),
        migrations.AlterUniqueTogether(
            name="selection",
            unique_together={("element", "user")},
        ),
        migrations.AlterUniqueTogether(
            name="mlclass",
            unique_together={("name", "corpus")},
        ),
        migrations.AddIndex(
            model_name="metadata",
            index=models.Index(django.db.models.functions.comparison.Cast("value", output_field=models.FloatField()), condition=models.Q(("type", arkindex.documents.models.MetaType["Numeric"])), name="metadata_numeric_index"),
        ),
        migrations.AddConstraint(
            model_name="metadata",
            constraint=models.CheckConstraint(check=models.Q(models.Q(("type", arkindex.documents.models.MetaType["Numeric"]), _negated=True), ("value__iregex", "^[+-]?(?:\\d+(?:\\.\\d*)?|\\.\\d+)(?:E[+-]?\\d+)?$"), _connector="OR"), name="metadata_numeric_values"),
        ),
        migrations.AddConstraint(
            model_name="metadata",
            constraint=models.CheckConstraint(check=models.Q(("worker_version_id__isnull", False), ("worker_run_id__isnull", True), _connector="OR"), name="metadata_worker_run_requires_worker_version"),
        ),
        migrations.AlterUniqueTogether(
            name="entitytype",
            unique_together={("name", "corpus")},
        ),
        migrations.AlterUniqueTogether(
            name="entityrole",
            unique_together={("parent_name", "child_name", "parent_type", "child_type", "corpus")},
        ),
        migrations.AddIndex(
            model_name="entity",
            index=models.Index(fields=["corpus_id", "name", "id"], name="entity_list_index"),
        ),
        migrations.AddConstraint(
            model_name="entity",
            constraint=models.CheckConstraint(check=models.Q(("worker_run_id__isnull", True), ("worker_version_id__isnull", False), _connector="OR"), name="entity_worker_run_requires_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="elementtype",
            constraint=models.UniqueConstraint(fields=("corpus", "slug"), name="corpus_unique_type_slug"),
        ),
        migrations.AddIndex(
            model_name="elementpath",
            index=django.contrib.postgres.indexes.GinIndex(fields=["path"], name="documents_e_path_15a4b8_gin"),
        ),
        migrations.AddIndex(
            model_name="elementpath",
            index=models.Index(models.F("path__last"), name="element_path_last"),
        ),
        migrations.AddConstraint(
            model_name="elementpath",
            constraint=models.UniqueConstraint(fields=("element", "path"), name="unique_element_paths"),
        ),
        migrations.AddConstraint(
            model_name="elementpath",
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable["DEFERRED"], expressions=[("element", "="), (django.db.models.functions.comparison.Least("path__len", 1), "<>")], name="unique_top_level"),
        ),
        migrations.AddConstraint(
            model_name="elementpath",
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable["DEFERRED"], expressions=[("element", "="), ("path__last", "="), ("ordering", "<>")], name="unique_element_orderings"),
        ),
        migrations.AddConstraint(
            model_name="elementpath",
            constraint=django.contrib.postgres.constraints.ExclusionConstraint(deferrable=django.db.models.constraints.Deferrable["DEFERRED"], expressions=[("path__last", "="), ("ordering", "="), ("element", "<>")], name="unique_parent_orderings"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(models.Q(("image_id", None), ("polygon", None)), models.Q(models.Q(("image_id", None), ("polygon", None), _connector="OR"), _negated=True), _connector="OR"), name="element_image_and_polygon"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("polygon", None), ("polygon__isclosed", True), _connector="OR"), name="element_polygon_closed"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("polygon", None), ("polygon", django.contrib.gis.db.models.functions.SnapToGrid("polygon", 1)), _connector="OR"), name="element_polygon_integer_coordinates"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("polygon", None), ("polygon__numpoints__gte", 4), _connector="OR"), name="element_polygon_size"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("rotation_angle__gte", 0), ("rotation_angle__lte", 359)), name="element_rotation_angle"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("creator_id", None), ("worker_version_id", None), _connector="OR"), name="element_creator_nand_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="element",
            constraint=models.CheckConstraint(check=models.Q(("worker_run_id__isnull", True), ("worker_version_id__isnull", False), _connector="OR"), name="element_worker_run_requires_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="classification",
            constraint=models.CheckConstraint(check=models.Q(("worker_version_id__isnull", False), ("worker_run_id__isnull", True), _connector="OR"), name="classification_worker_run_requires_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="classification",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_version_id__isnull", True)), fields=("element", "ml_class"), name="classification_unique_manual"),
        ),
        migrations.AddConstraint(
            model_name="classification",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_run_id__isnull", True), ("worker_version_id__isnull", False)), fields=("element", "ml_class", "worker_version"), name="classification_unique_worker_version"),
        ),
        migrations.AddConstraint(
            model_name="classification",
            constraint=models.UniqueConstraint(condition=models.Q(("worker_run_id__isnull", False)), fields=("element", "ml_class", "worker_run"), name="classification_unique_worker_run"),
        ),
        migrations.AlterUniqueTogether(
            name="allowedmetadata",
            unique_together={("corpus", "type", "name")},
        ),
    ]
